import React from 'react';

declare global {
    interface Window {
        documentPictureInPicture?: {
            requestWindow: (options?: {
                width?: number;
                height?: number;
                disallowReturnToOpener?: boolean;
            }) => Promise<Window>;
        };
    }
}
declare const canUsePip: boolean;
type PIPPortalProps = {
    width?: number;
    height?: number;
    disallowReturnToOpener?: boolean;
    children: React.ReactNode;
    /**
     * Called when the PIP window is closed.
     */
    onClose?: () => void;
    /**
     * Whether to copy stylesheets from the main window to the PIP window.
     * @default true
     */
    shouldCopyStyles?: boolean;
};
/**
 * A React component that renders its children in a Picture-in-Picture window.
 */
declare const PIPPortal: React.FC<PIPPortalProps>;

export { PIPPortal, type PIPPortalProps, canUsePip };
